using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;

namespace DiskUsage
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TreeView MainTreeView;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.MainTreeView = new System.Windows.Forms.TreeView();
			this.SuspendLayout();
			// 
			// MainTreeView
			// 
			this.MainTreeView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.MainTreeView.ImageIndex = -1;
			this.MainTreeView.Location = new System.Drawing.Point(0, 0);
			this.MainTreeView.Name = "MainTreeView";
			this.MainTreeView.SelectedImageIndex = -1;
			this.MainTreeView.Size = new System.Drawing.Size(472, 280);
			this.MainTreeView.TabIndex = 0;
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(472, 278);
			this.Controls.Add(this.MainTreeView);
			this.Name = "MainForm";
			this.Text = "Disk Usage";
			this.Load += new System.EventHandler(this.MainForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			MainForm form = new MainForm();
			
			Application.Run(form);
		}

		public class TreeNodeData
		{
			public long size;
			public string name;
		}

		private static string basename(string filename)
		{
			int lastidx = filename.LastIndexOf('\\');
			if( lastidx == filename.Length - 1 )
				return filename;
			else
				return filename.Substring(lastidx+1);
		}

		private static string FormatSize(long size)
		{
			string fmt = "{0:F2}";
			
			if( size < 1000 )
				return "" + String.Format(fmt, size);
			else if( size < 1000*1000 )
				return String.Format(fmt, size/1000.0) + "K";
			else if( size < 1000*1000*1000 )
				return String.Format(fmt, size/(1000.0*1000)) + "M";
			else
				return String.Format(fmt, size/(1000.0*1000*1000)) + "G";

		}

		public class Sorter : System.Collections.IComparer
		{
			public Sorter(int type)
			{
				this.type = type;
			}

			public int Compare(object x, object y)
			{
				TreeNode nx = (TreeNode)x;
				TreeNode ny = (TreeNode)y;

				TreeNodeData dx = (TreeNodeData)nx.Tag;
				TreeNodeData dy = (TreeNodeData)ny.Tag;

				if( type == 0 ) //alphabetical
				{
					return String.Compare(dx.name, dy.name);					
				}
				else if( type == 1 )
				{
					long val = (dx.size - dy.size);
					if( val < 0 )
						return -1;
					else if( val > 0 )
						return 1;
					else
						return 0;
				}
				else
					return 0;
			}

			int type;
		}

		private void SortBySize(TreeNodeCollection inputs)
		{
			//TreeNodeCollection outputs = new TreeNodeCollection();
			
			TreeNode[] inarray = new TreeNode[inputs.Count];
			inputs.CopyTo(inarray, 0);
			Array.Sort(inarray, new Sorter(1));

			inputs.Clear();
			inputs.AddRange(inarray);
		}

		private long TraverseDirectories(string dirname, int level, TreeNode parent)
		{
			if( level > 3 )
				return 0;

			for(int i=0; i<level; i++)
				Console.Write("\t");
			Console.WriteLine(basename(dirname));

			TreeNode node = new TreeNode(basename(dirname));
			TreeNodeData data = new TreeNodeData();
			data.name = basename(dirname);
			node.Tag = data;
				
			if( level == 0 )
				MainTreeView.Nodes.Add(node);
			else
				parent.Nodes.Add(node);
			
			long size=0;
			string[] subdirnames = Directory.GetDirectories(dirname);
			foreach(string subdirname in subdirnames)
				size += TraverseDirectories(subdirname, level+1, node);

			string[] files = Directory.GetFiles(dirname);
			foreach(string file in files)
			{
				FileInfo info = new FileInfo(file);
				TreeNode filenode = new TreeNode(info.Name);
				size += info.Length;
				node.Nodes.Add(filenode);
				TreeNodeData filedata = new TreeNodeData();
				filedata.name = info.Name;
				filedata.size = info.Length;
				filenode.Tag = filedata;
				filenode.Text = "(" + FormatSize(info.Length) + ") " + info.Name;

			}

			data.size = size;
			node.Text = "(" + FormatSize(data.size) + ") " + data.name;

			SortBySize(node.Nodes);
			return size;
		}

		private long ComputeDirectorySize(string dirname, int level)
		{
			string[] files = Directory.GetFiles(dirname);
			
			long size=0;
			foreach(string file in files)
			{
				FileInfo info = new FileInfo(file);
				size += info.Length;
			}
				
			string[] subdirnames = Directory.GetDirectories(dirname);
			foreach(string subdirname in subdirnames)
				size += ComputeDirectorySize(subdirname, level+1);
			
			
			//TreeNode node = new TreeNode(basename(dirname));
			//node.
			//MainTreeView.Nodes.Add(
			return size;
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			FolderBrowserDialog dialog = new FolderBrowserDialog();
            
			dialog.ShowDialog();
			TraverseDirectories(dialog.SelectedPath, 0, null);
      	}
	}
}
